StepRequest (Java SE 26 & JDK 26)
Description: declaration: module: jdk.jdi, package: com.sun.jdi.request, interface: StepRequest
Keywords: com.sun.jdi.request.StepRequest interface

# Interface StepRequest

All Superinterfaces:
  `EventRequest, Mirror`

public interface StepRequest extends EventRequest
Request for notification when a step occurs in the target VM. When an enabled StepRequest is satisfied, an `event set` containing a `StepEvent` will be placed on the `EventQueue`. The collection of existing StepRequests is managed by the `EventRequestManager`

Since:
  1.3
See Also:
  - `StepEvent`
  - `EventQueue`
  - `EventRequestManager`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `STEP_INTO`
  Step into any newly pushed frames
  `static final int`
  `STEP_LINE`
  Step to the next location on a different line
  `static final int`
  `STEP_MIN`
  Step to the next available location
  `static final int`
  `STEP_OUT`
  Step out of the current frame
  `static final int`
  `STEP_OVER`
  Step over any newly pushed frames

  ### Fields declared in interface EventRequest

  `SUSPEND_ALL, SUSPEND_EVENT_THREAD, SUSPEND_NONE`
  Modifier and Type
  Field
  Description
  `static final int`
  `SUSPEND_ALL`
  Suspend all threads when the event occurs
  `static final int`
  `SUSPEND_EVENT_THREAD`
  Suspend only the thread which generated the event when the event occurs
  `static final int`
  `SUSPEND_NONE`
  Suspend no threads when the event occurs

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addClassExclusionFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name does not match a restricted regular expression.
  `void`
  `addClassFilter(ReferenceType refType)`
  Restricts the events generated by this request to those whose location is in the given reference type or any of its subtypes.
  `void`
  `addClassFilter(String classPattern)`
  Restricts the events generated by this request to those whose location is in a class whose name matches a restricted regular expression.
  `void`
  `addInstanceFilter(ObjectReference instance)`
  Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.
  `int`
  `depth()`
  `int`
  `size()`
  `ThreadReference`
  `thread()`

  ### Methods declared in interface EventRequest

  `addCountFilter, disable, enable, getProperty, isEnabled, putProperty, setEnabled, setSuspendPolicy, suspendPolicy`
  Modifier and Type
  Method
  Description
  `void`
  `addCountFilter(int count)`
  Limit the requested event to be reported at most once after a given number of occurrences.
  `void`
  `disable()`
  Same as `setEnabled(false)`.
  `void`
  `enable()`
  Same as `setEnabled(true)`.
  `Object`
  `getProperty(Object key)`
  Returns the value of the property with the specified key.
  `boolean`
  `isEnabled()`
  Determines if this event request is currently enabled.
  `void`
  `putProperty(Object key, Object value)`
  Add an arbitrary key/value "property" to this request.
  `void`
  `setEnabled(boolean val)`
  Enables or disables this event request.
  `void`
  `setSuspendPolicy(int policy)`
  Determines the threads to suspend when the requested event occurs in the target VM.
  `int`
  `suspendPolicy()`
  Returns a value which describes the threads to suspend when the requested event occurs in the target VM.

  ### Methods declared in interface Mirror

  `toString, virtualMachine`
  Modifier and Type
  Method
  Description
  `String`
  `toString()`
  Returns a String describing this mirror
  `VirtualMachine`
  `virtualMachine()`
  Gets the VirtualMachine to which this Mirror belongs.

- ## Field Details

  - ### STEP_INTO

    static final int STEP_INTO
    Step into any newly pushed frames
    See Also:
      - Constant Field Values

  - ### STEP_OVER

    static final int STEP_OVER
    Step over any newly pushed frames
    See Also:
      - Constant Field Values

  - ### STEP_OUT

    static final int STEP_OUT
    Step out of the current frame
    See Also:
      - Constant Field Values

  - ### STEP_MIN

    static final int STEP_MIN
    Step to the next available location
    See Also:
      - Constant Field Values

  - ### STEP_LINE

    static final int STEP_LINE
    Step to the next location on a different line
    See Also:
      - Constant Field Values

- ## Method Details

  - ### thread

    ThreadReference thread()
    Returns:
      the thread on which the step event is being requested.

  - ### size

    int size()
    Returns:
      the step size

  - ### depth

    int depth()
    Returns:
      the step depth

  - ### addClassFilter

    void addClassFilter(ReferenceType refType)
    Restricts the events generated by this request to those whose location is in the given reference type or any of its subtypes. An event will be generated for any location in a reference type that can be safely cast to the given reference type.
    Parameters:
      `refType` - the reference type to filter on.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addClassFilter

    void addClassFilter(String classPattern)
    Restricts the events generated by this request to those whose location is in a class whose name matches a restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
    Parameters:
      `classPattern` - the pattern String to filter for.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addClassExclusionFilter

    void addClassExclusionFilter(String classPattern)
    Restricts the events generated by this request to those whose location is in a class whose name does not match a restricted regular expression. Regular expressions are limited to exact matches and patterns that begin with '*' or end with '*'; for example, "*.Foo" or "java.*".
    Parameters:
      `classPattern` - the pattern String to filter against.
    Throws:
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.

  - ### addInstanceFilter

    void addInstanceFilter(ObjectReference instance)
    Restricts the events generated by this request to those in which the currently executing instance ("this") is the object specified.

    Not all targets support this operation. Use `VirtualMachine.canUseInstanceFilters()` to determine if the operation is supported.

    Parameters:
      `instance` - the object which must be the current instance in order to pass this filter.
    Throws:
      `UnsupportedOperationException` - if the target virtual machine does not support this operation.
      `InvalidRequestStateException` - if this request is currently enabled or has been deleted. Filters may be added only to disabled requests.
    Since:
      1.4